//                
//  NEWS CLOCK  
//        

import processing.xml.*;


String rss_url[];
PImage am, pm, clock, titolo, legenda;
XMLElement rss0, rss1, rss2, rss3, rss4;
String[] title0, title1, title2, title3, title4;
String[] pubDate0, pubDate1, pubDate2, pubDate3, pubDate4;
color color0;
color color1;
color color2;
color color3;
color color4;
int num_news;
PFont font;


void setup(){
  size(900, 600);
  smooth();
  background(255);
  num_news = 10;
  setupSlide();
  font = loadFont("helvetica10.vlw"); 
  textFont(font);   

  rss_url = new String[5];
  
  // REPUBBLICA.IT
  rss_url[0] = "http://rss.feedsportal.com/c/32275/f/438646/index.rss"; // calcio
  rss_url[1] = "http://rss.feedsportal.com/c/32275/f/438639/index.rss"; // economia
  rss_url[2] = "http://rss.feedsportal.com/c/32275/f/438642/index.rss"; // politica
  rss_url[3] = "http://rss.feedsportal.com/c/32275/f/438644/index.rss"; // cultura
  rss_url[4] = "http://www.repubblica.it/rss/rubriche/rss2.0.xml"; // persone
  
  // SPIGEL.DE
  /*
  rss_url[0] = "http://www.spiegel.de/sport/fussball/index.rss"; // calcio
  rss_url[1] = "http://www.spiegel.de/wirtschaft/index.rss"; // economia
  rss_url[2] = "http://www.spiegel.de/politik/index.rss"; // politica
  rss_url[3] = "http://www.spiegel.de/kultur/index.rss"; // cultura
  rss_url[4] = "http://www.spiegel.de/panorama/index.rss"; // persone
  */

  am = loadImage("am.png");
  pm = loadImage("pm.png");
  clock = loadImage("clock.png");
  titolo = loadImage("titolo.png");
  legenda = loadImage("legenda.png");

  rss0 = new XMLElement(this, rss_url[0]);
  rss1 = new XMLElement(this, rss_url[1]);
  rss2 = new XMLElement(this, rss_url[2]);
  rss3 = new XMLElement(this, rss_url[3]);
  rss4 = new XMLElement(this, rss_url[4]);
  
  color0 = #b81a19;
  color1 = #ff9000;
  color2 = #cbb11e;
  color3 = #6eb444;
  color4 = #212ede;
}

void draw(){

  background(255);
  imageMode(CENTER);
  image(clock, 250-(clock.width/2), 250-(clock.height/2));
  image(clock, 650-(clock.width/2), 250-(clock.height/2));
  image(titolo, 35, 15);
  image(legenda, 0, 443);
  
  stroke(100,100,100, 35);
  line(40, 50, width-40, 50);
  line(40, 440, width-40, 440);
  
  scanFeed();
  stroke(100,100,100, 45);
  noFill();
  ellipse(250, 250, 100, 100);
  ellipse(250, 250, 150, 150);
  ellipse(250, 250, 200, 200);
  ellipse(250, 250, 250, 250);
  ellipse(250, 250, 300, 300);
  ellipse(650, 250, 100, 100);
  ellipse(650, 250, 150, 150);
  ellipse(650, 250, 200, 200);
  ellipse(650, 250, 250, 250);
  ellipse(650, 250, 300, 300);
  
  stroke(100,100,100, 45);
  fill(255, 255, 255);
  ellipse(250, 250, 50, 50);
  ellipse(650, 250, 50, 50);
  
  imageMode(CENTER);
  image(am, 250-(am.width/2), 250-(am.height/2));
  image(pm, 650-(pm.width/2), 250-(pm.height/2));
  
  drawSlide();
  fill(148,147,147);
  text(("news per category: "+num_news), 40, 90);
}




void drawFeed(String[] title, String[] pubDate, color colore, int w){

  String description;
  String time;
  String meridiano;
  int minuti_totali;
  float delta;
  float posizione;
  float start;
  int x = 0;
  int y = 250;
  String[] words;
  int num_words;
  int alfa = 0;
  if(title.length < num_news) {
    num_news = title.length;
  }
  
  for(int i=0; i<num_news; i++){
    description = title[i];
    time = pubDate[i];

    // calcolo numero parole per news
    words = splitTokens(description);
    num_words = words.length;
    
    // orologio per ogni news
    time = time.substring(17, 25);
    int ora = int(time.substring(0,2))+2;
    int minuto = int(time.substring(3,5));
    if(minuto < 10){ minuto = 10; }
    if(ora >= 12){ meridiano = "PM"; ora = ora-12; } else { meridiano = "AM"; }
    posizione = ora+(minuto/60.0);
    delta = 2*PI/12; // angolo che rappresenta un minuto
    start = posizione*delta;
    if(meridiano=="AM"){ x = 250; } else if(meridiano=="PM"){ x = 650; }
    
    if(num_words > 70){ alfa = 100; }
    if(num_words <= 70){ alfa = 90; }
    if(num_words <= 60){ alfa = 80; }
    if(num_words <= 50){ alfa = 70; }
    if(num_words <= 40){ alfa = 60; }
    if(num_words <= 30){ alfa = 50; }
    if(num_words <= 20){ alfa = 30; }
    if(num_words <= 10){ alfa = 20; }
    
    stroke(colore, alfa);
    fill(colore, alfa);
    start = start - PI/2; // 0° = 12h
    arc(x, y, w, w, start, start+(delta/3));
    fill(#ffffff);
    noStroke();
    ellipse(250, 250, w-50, w-50);
    ellipse(650, 250, w-50, w-50);
  }

}

